module altera_gts_fifomem #(
    parameter DSIZE = 8,
    parameter ASIZE = 4
) (
    input               wrclk,
    input               wrrst_n,
    input               wren,
    input [DSIZE-1:0]   wrdata,
    input [ASIZE-1:0]   wraddr,
    input [ASIZE-1:0]   rdaddr,
    output [DSIZE-1:0]  rddata
);

localparam DEPTH = 1 << ASIZE;

reg [DSIZE-1:0] fifomem [0:DEPTH-1];

genvar i;
generate
    for (i=0; i<DEPTH; i=i+1) begin : fifomem_loop
        always @(posedge wrclk or negedge wrrst_n) begin
            if (!wrrst_n)
                fifomem[i] <= {DSIZE{1'b0}};
            else if (wren & (wraddr == i))
                fifomem[i] <= wrdata;
        end
    end
endgenerate

assign rddata = fifomem[rdaddr];

endmodule


